unit testfrm;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, TPEComp, ExtCtrls;

type
    TForm1 = class(TForm)
        Button1: TButton;
        Button2: TButton;
        Button3: TButton;
        Button4: TButton;
        Button5: TButton;
        Panel1: TPanel;
        Button6: TButton;
        Button7: TButton;
        Button8: TButton;
        procedure FormClose(Sender: TObject; var Action: TCloseAction);
        procedure Button1Click(Sender: TObject);
        procedure Button2Click(Sender: TObject);
        procedure Button3Click(Sender: TObject);
        procedure Button4Click(Sender: TObject);
        procedure Button5Click(Sender: TObject);
        procedure Button6Click(Sender: TObject);
        procedure Button7Click(Sender: TObject);
        procedure Button8Click(Sender: TObject);
    private
    { Private declarations }
    public
    { Public declarations }
    end;

var
    Form1: TForm1;
    PropertiesEdit : TPropertiesEdit;
    RealBrowser,IntegerBrowser,RecordBrowser : TUserBrowser;

implementation

uses BROWSER;

{$R *.DFM}

function RBrowser(var Value: variant) : boolean;
begin
    ShowMessage('Making real number 123.456');
    Value := 123.456;
    Result := True;
end;

function IBrowser(var Value: variant) : boolean;
begin
    ShowMessage('Making integer number 123456');
    Value := 123456;
    Result := True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    PropertiesEdit.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
    i : integer;
    Rec : variant;
begin
    Rec := VarArrayCreate([0,3],varVariant);
    Rec[0] := 'Test name';
    Rec[1] := Male;
    Rec[2] := '123456';
    Rec[3] := 'Comment hello';
    RecordBrowser := BROWSER.Execute;
    RealBrowser := RBrowser;
    IntegerBrowser := IBrowser;
    if Assigned(PropertiesEdit) then PropertiesEdit.Free;
    PropertiesEdit := TPropertiesEdit.Create(self);
    PropertiesEdit.Parent := Panel1;
    LockWindowUpdate(PropertiesEdit.Handle);
    PropertiesEdit.Align := alClient;
    with PropertiesEdit do begin
        AddObject('1st Object');
        AddObject('2nd Object');
        AddObject('3nd Object');
        ObjectIndex := 0;
        AddPropertyConst('String List 1',emDropDownList,['ABC','XYZ'],'ABC');
        AddPropertyConst('Boolean List 1',emDropDownList,[False,True],False);
        AddPropertyConst('Real List 1',emDropDownList,[1.1,1.2,1.3],1.1);
        i := AddPropertyConst('Real Edit 1',emUserEdit,[#0],1.01);
        NDigits[i] := 2;
        i := AddPropertyConst('Integer Edit 1 (5<x<20)',emUserEdit,[#0],1);
        MaxValue[i]:=20;
        MinValue[i]:=5;
        AddPropertyConst('String Edit 1',emUserEdit,[#0],'Hello');
        AddPropertyConst('Boolean Edit 1',emUserEdit,[#0],True);
        i := AddPropertyConst('Real Browse Edit 1',emUserEditBrowse,[#0],1.01);
        Browser[i] := RealBrowser;
        NDigits[i] := 3;
        i := AddPropertyConst('Integer Browse Edit 1',emUserEditBrowse,[#0],1);
        Browser[i] := IntegerBrowser;
        i := AddPropertyConst('File Browse 1',emFileBrowse,[#0],' ');
        Filter[i] := 'All Files|*.*';
        AddPropertyConst('Font Browser 1',emFontBrowse,[#0],' ');
        AddPropertyConst('Color Browser 1',emColorBrowse,[#0],TColor(0));
        ObjectIndex := 1;
        i := AddPropertyConst('Record Browser 2',emUserBrowse,[#0],Rec);
        Browser[i] := RecordBrowser;
        ObjectIndex := 2;
        AddPropertyConst('String List 3',emDropDownList,['ABC','XYZ'],'ABC');
        AddPropertyConst('Real List 3',emDropDownList,[1.1,1.2,1.3],1.1);
        AddPropertyConst('Real Edit 3',emUserEdit,[#0],1.01);
        AddPropertyConst('Integer Edit 3',emUserEdit,[#0],1);
        i := AddPropertyConst('Real Browse Edit 3',emUserEditBrowse,[#0],1.01);
        Browser[i] := RealBrowser;
        i := AddPropertyConst('Integer Browse Edit 3',emUserEditBrowse,[#0],1);
        Browser[i] := IntegerBrowser;
        i := AddPropertyConst('File Browse 3',emFileBrowse,[#0],' ');
        Filter[i] := 'All Files|*.*';
        AddPropertyConst('Font Browser 3',emFontBrowse,[#0],' ');
        AddPropertyConst('Color Browser 3',emColorBrowse,[#0],TColor(0));
        PropertyIndex := 0;
    end;
    LockWindowUpdate(0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    if Assigned(PropertiesEdit) then begin
        PropertiesEdit.Free;
        PropertiesEdit := nil;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    if Assigned(PropertiesEdit) then
        PropertiesEdit.ShowObjectList := not PropertiesEdit.ShowObjectList;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    if Assigned(PropertiesEdit) then
        PropertiesEdit.Visible := not PropertiesEdit.Visible;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    if Assigned(PropertiesEdit) then
        PropertiesEdit.Enabled := not PropertiesEdit.Enabled;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    if Assigned(PropertiesEdit) then with PropertiesEdit do begin
        case Align of
            alNone : begin
                Align := alTop;
                Height := Panel1.Height-60;
            end;
            alTop : begin
                Align := alBottom;
                Top := 60;
            end;
            alBottom : begin
                Align := alLeft;
                Width := Panel1.Width-60;
            end;
            alLeft : begin
                Align := alRight;
                Left := 60;
            end;
            alRight  : Align := alClient;
            alClient : begin
                Align := alNone;
                Top := 50;
                Left := 50;
                Width := Panel1.Width-100;
                Height := Panel1.Height-100;
            end;
        end;
    end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    if Assigned(PropertiesEdit) then with PropertiesEdit do
        IsVisible[PropertyIndex] := not IsVisible[PropertyIndex];
end;

procedure TForm1.Button8Click(Sender: TObject);
var
    i,j : integer;
begin
    if Assigned(PropertiesEdit) then with PropertiesEdit do
        for i := 0 to NumObjs-1 do begin
            ObjectIndex := i;
            for j := 0 to NumProps[i]-1 do IsVisible[j] := True;
        end;
end;

end.
